/* 
 * UADE
 * 
 * Support for ALSA sound
 * 
 * Copyright 2004 Heikki Orsila <heikki.orsila@iki.fi>
 */

#include <alsa/asoundlib.h>

#include "uade.h"

extern uae_u16 sndbuffer[];
extern uae_u16 *sndbufpt;
extern int sndbufsize;
extern int sound_bytes_per_sample;
extern snd_pcm_t *alsa_playback_handle;
extern int alsa_to_frames_divisor;

extern void finish_sound_buffer (void);


static __inline__ void check_sound_buffers (void) {
   if ((char *) sndbufpt - (char *) sndbuffer >= sndbufsize) {

      if ((char *) sndbufpt - (char *) sndbuffer > sndbufsize) {
	 fprintf(stderr, "uade: A bug in sound buffer writing. Report this!\n");
      }
      
      if (uade_check_sound_buffers(sndbuffer, sndbufsize, sound_bytes_per_sample)) {
	 int frames = sndbufsize / alsa_to_frames_divisor;
	 snd_pcm_writei(alsa_playback_handle, sndbuffer, frames);
#if 0
	 if (ret != frames) {
	    fprintf(stderr, "uade: couldn't write full buffer for alsa (%s)\n", snd_strerror(ret));
	 }
#endif
      }

      sndbufpt = sndbuffer;
   }
}

#define PUT_SOUND_BYTE(b) do { *(uae_u8 *)sndbufpt = b; sndbufpt = (uae_u16 *)(((uae_u8 *)sndbufpt) + 1); } while (0)
#define PUT_SOUND_WORD(b) do { *(uae_u16 *)sndbufpt = b; sndbufpt = (uae_u16 *)(((uae_u8 *)sndbufpt) + 2); } while (0)
#define PUT_SOUND_BYTE_LEFT(b) PUT_SOUND_BYTE(b)
#define PUT_SOUND_WORD_LEFT(b) PUT_SOUND_WORD(b)
#define PUT_SOUND_BYTE_RIGHT(b) PUT_SOUND_BYTE(b)
#define PUT_SOUND_WORD_RIGHT(b) PUT_SOUND_WORD(b)
#define SOUND16_BASE_VAL 0
#define SOUND8_BASE_VAL 128

#define DEFAULT_SOUND_MAXB 8192
#define DEFAULT_SOUND_MINB 8192
#define DEFAULT_SOUND_BITS 16
#define DEFAULT_SOUND_FREQ 44100
#define HAVE_STEREO_SUPPORT
